<?php
class YokokuOut {

	var $nameLimit = 15; // 名前長さ
	var $messageLimit = 140; // メッセージ長さ

	var $past = 20; // 1ページ件数
	var $logLimit = 499; // 保存件数
	var $rssLimit = 100; // rss件数
	var $nanashi = "ななしさん";
	var $cookieLimit = 30; // クッキー日数
	var $sendMeasures = 20; // 連投規制（秒）

	var $logfile = './log.txt';
	var $self = 'http://ss.hamachiya.com/yokoku.out/';
	var $font = './font.ttf'; // なんかttfフォント置いとく
	var $img = 'img/';

	function display() {
		$log = file($this->logfile);

		// コメント1件だけ
		if ($this->view) {
			foreach ($log as $row) {
				list($no, $message, $name, $time, $host, $filename) = explode("\t", mb_convert_encoding(rtrim($row), 'UTF-8'));
				if ($this->view == $no) {
					$html .= $this->htmlList($no, $message, $name, $time, $host, $filename);
					break;
				}
			}

		// 全件(ページング)
		} else {
			$pageLimit = $this->page * $this->past;
			$pageStart = ($pageLimit - $this->past) + 1;
			$c = 1;

			foreach ($log as $row) {
				if ($c < $pageStart or $c > $pageLimit) {
					$c++;
					continue;
				}

				list($no, $message, $name, $time, $host, $filename) = explode("\t", mb_convert_encoding(rtrim($row), 'UTF-8'));
				$html .= $this->htmlList($no, $message, $name, $time, $host, $filename);
				$c++;
			}
		}

		$html = '<ul id="yokokuList">' . $html . '</ul>';
		$html .= $this->paging($c);

		return $html;
	}

	function htmlList($no, $message, $name, $time, $host, $filename) {
		$name = ($name != '') ? htmlspecialchars($name, ENT_QUOTES, 'UTF-8') : $this->nanashi;
		$date = date('Y/m/d H:i:s', $time);

		$html = <<<_EoM_
<li>
	<div class="messageHeader">
		<span class="no"><a href="{$this->self}?v=$no">$no</a></span> : 
		<span class="name">$name</span> 
		<span class="date">[$date]</span>
	</div>
	<div class="messageBody"><img src="{$this->img}{$filename}" alt="" /></div>
</li>
_EoM_;

		return $html;
	}

	function displayRss() {
		header('Content-Type: text/xml;charset=utf-8');

		$log = file($this->logfile);

		$li = '';
		$items = '';

		$c = 0;
		foreach ($log as $row) {
			if (++$c > $this->rssLimit) {
				break;
			}

			list($no, $message, $name, $time, $host, $filename) = explode("\t", mb_convert_encoding(rtrim($row), 'UTF-8'));

			$name = ($name != '') ? htmlspecialchars($name, ENT_QUOTES, 'UTF-8') : $this->nanashi;
			$date = date('Y/m/d H:i:s', $time);

			$items .= <<<_EoM_
	<item>
		<title>{$no} : {$name}の予告 [{$date}]</title>
		<link>{$this->self}?v={$no}</link>
		<description><![CDATA[
			<p><img src="{$this->self}{$this->img}$filename" /></p>
		]]></description>
		<guid>{$no}</guid>
		<author>{$name}</author>
	</item>

_EoM_;
		}

		echo <<<_EoM_
<?xml version="1.0" encoding="UTF-8" ?>
<rss version="2.0">
<channel>
	<title>予告.out - 予告ができる掲示板</title>
	<link>{$this->self}</link>
	<description>ここは、みんなが楽しく、いろんな予告をする掲示板です！</description>
	<generator>予告.out</generator>

$items

</channel>
</rss>

_EoM_;

		exit;
	}

	function add() {
		// 本文なし
		if ($this->message == '') {
			header('Location: ' . $this->self);
			exit;
		}

		// めんどくさいからリファラでCSRF対策しちゃいますね
		if (! strpos($this->host, 'docomo')) {
			if (strpos($this->referer, 'http://' . $this->server) !== 0) {
				exit;
			}
		}

		$now = time();
		setcookie('yo_name', $this->name,$now+(60*60*24*$this->cookieLimit));

		$log = file($this->logfile);
		list($no, $message, $name, $time, $host, $filename) = explode("\t", $log[0]);
		$no = $no ? $no : 0;

		if ($this->sendMeasures != 0 and $host == $this->host) {
			if (($time + $this->sendMeasures) > $now) {
				echo $this->systemMessage('あと' . (($time + $this->sendMeasures) - $now) . '秒待って');
				exit;
			}
		}
		if (mb_strlen($this->message) > ($this->messageLimit)) {
			echo $this->systemMessage('メッセージ長すぎ？');
			exit;
		}
		if (mb_strlen($this->name) > ($this->nameLimit)) {
			echo $this->systemMessage('名前長すぎ？');
			exit;
		}


		$filename = md5(microtime(true) . $this->message) . '.gif';
		$this->str2img($this->message, $this->img . $filename);

		$this->message = $this->strip($this->message);
		$this->name = $this->strip($this->name);

		$fp = fopen($this->logfile, 'w') or exit($this->systemMessage('オープン失敗？'));
		flock($fp, LOCK_EX) or exit($this->systemMessage('ロック失敗？'));

		fputs($fp,
			(++$no) . "\t" .
			$this->message . "\t" .
			$this->name . "\t" .
			$now . "\t" .
			$this->host . "\t" .
			$filename . "\n"
		);

		$i = 0;
		foreach ($log as $row) {
			if ($i >= $this->logLimit) { break; }
			fputs($fp, $row);
			$i++;
		}
		flock($fp, LOCK_UN);
		fclose($fp);

		header('Location: ' . $this->self);
	}

	function strip($str) {
		$str = str_replace("\t", '', $str);
		$str = str_replace("\r", '', $str);
		$str = str_replace("\n", '', $str);
		return $str;
	}

	function paging($n) {
		$n--;
		$html .= '<div class="paging">';
		$pageCount = intval($n / $this->past);
		if ($n % $this->past != 0) {
			$pageCount++;
		}

		if ($this->page != 1) {
			$beforePage = $this->page - 1;
			$html .= ' <a href="' . $this->self . '?p=' . $beforePage . '">&lt;&lt;</a> ';
		}
		for ($p=1; $p<=$pageCount; $p++) {
			if ($pageCount <= 1) {
				break;
			}

			if ($p != $this->page) {
				$html .= ' <a href="' . $this->self . '?p=' . $p . '">[' . $p . ']</a> ';
			} else {
				$html .= ' <strong>[' . $p . ']</strong> ';
			}

			if ($this->page < $pageCount) {
				if ($p == $pageCount) {
					$nextPage = $this->page + 1;
					$html .= ' <a href="' . $this->self . '?p=' . $nextPage . '">&gt;&gt;</a> ';
				}
			}
		}

		$html .= '</div>';

		return $html;
	}

	function systemMessage($err_message) {
		$html .= '<div class="systemMessage">' . $err_message . '</div>';
		$html .= '<div class="opr"><a href="' . $this->self . '">もどる</a></div>';

		return $html;
	}

	function str2img($str, $file) {
		// もしこのフォントでこんな文字列かいたら
		// 縦横これくらいになるよって教えてくれるやつ。なんか配列
		$imgData = imagettfbbox(12, 0, $this->font, $str);

		// 箱をつくる
		// フォントによって文字画像が半端な位置になったら↓適当に調整してね
		$im = imagecreatetruecolor($imgData[4] + 18, $imgData[1] + 24);

		$color = imagecolorallocate($im, 255, 255, 255);

		// 箱に文字いれる
		imagettftext($im, 12, 0, 6, 18, $color, $this->font, $str);

		// 書き出すよ。file指定しなかったら、そのまま表示することもできるよ
		imagegif($im, $file);
		imagedestroy($im);
	}

	function YokokuOut() {
		// newされたら、まずここから

		$this->message = mb_convert_encoding($_POST['message'], 'UTF-8');
		$this->name = mb_convert_encoding($_POST['name'], 'UTF-8');
		$this->mode = $_REQUEST['m'];
		$this->page = $_GET['p'] ? $_GET['p'] : 1;
		$this->view = preg_match("/^\d+$/", $_GET['v']) ? $_GET['v'] : 0;

		$this->addr = getenv('REMOTE_ADDR');
		$this->host = getenv('REMOTE_HOST');
		if($this->host == '' or $this->host == $this->addr){
			$this->host = gethostbyaddr($this->addr);
		}

		$this->referer = $_SERVER['HTTP_REFERER'];
		$this->server = $_SERVER['HTTP_HOST'];

		$this->c_name = mb_convert_encoding($_COOKIE['yo_name'], 'UTF-8');

		switch ($this->mode) {
			case 'add' :
				$this->add();
				break;
			case 'rss' :
				$this->displayRss();
				break;
		}
	}
}

$yo = new YokokuOut;

?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
 "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja" dir="ltr">

<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<meta http-equiv="Content-Language" content="ja" />
	<title>予告.out - 予告ができる掲示板</title>
	<meta name="keywords" content="犯行予告,だめ,絶対" />
	<meta http-equiv="Content-Style-Type" content="text/css" />
	<meta http-equiv="Content-Script-Type" content="text/javascript" />

	<link rel="alternate" type="application/rss+xml" title="予告.out (RSS)" href="<?= $yo->self ?>?m=rss" />

	<style type="text/css"><!--
		body {
			padding: 0.5em;
			background: #000;
			color: #fff;
		}

		a {
			color: #66f;
		}

		a:hover {
			color: #f33;
		}

		img {
			border: 0;
		}

		#header {
			margin: 0;
			padding: 0;
			position: relative;
		}

			#header h1 {
				margin: 0;
				padding: 0;
			}

			#header p {
				line-height: 1.4;
			}

			#header #rss {
				position: absolute;
				top: 0;
				right: 0;
			}

		#yokokuForm {
			border: 3px solid #ccc;
			padding: 0.5em;
			margin: 0;
		}

			#yokokuForm #inputName {
				width: 10em;
			}

			#yokokuForm #inputMessage {
				width: 30em;
				height: 3.5em;
			}

		#yokokuList {
			margin: 1em 0;
		}

			#yokokuList li {
				list-style-type: none;
				margin-bottom: 1.5em;
			}

		.messageHeader {
		}

			.messageHeader .name {
				font-weight: bold;
			}

			.messageHeader .date {
				color: #ccc;
			}

		#footer {
			margin: 1em 0 0 0;
			border-top: 3px solid #ccc;
			padding: 0.5em 0 0 0;
		}
	--></style>
</head>


<body bgcolor="black" text="white">
<div id="header">
<h1><a href="<?= $yo->self ?>"><img src="yokoku.out.logo.gif" width="375" height="100" alt="予告.out" /></a></h1>

<? if (! $yo->view) { ?>
<p>
ここは、みんなが楽しく、いろんな予告をする掲示板です！<br />
ここに書いた予告は、<strong style="color:red">文字が画像の形式になっちゃう</strong>ので、サーチエンジンだとか、<a href="http://headlines.yahoo.co.jp/hl?a=20080611-00000109-jij-pol">2億円の検知ソフト</a>とか、<a href="http://yokoku.in/">0億円で2時間の犯行予告共有サービス</a>とかにも引っかかりません！ やったね安心だね！
</p>

<p>
お互いを監視しあうよりも、この掲示板とかその亜種たちが、ちょっとだけ広まって、みんなが気がねなく予告できちゃう楽しいネットになればいいな！ 下にソースコードを置いておいたので、もっとすてきな感じに作り直してみてくださいね！
</p>

<p>
だからといって、犯行予告なんかに使っちゃだめですよ！ ぜったい！
</p>
<? } ?>

<p id="rss">
<a href="<?= $yo->self ?>?m=rss"><img src="<?= $yo->self ?>rss.gif" alt="RSS" /> RSS</a>
</p>
</div>

<? if (! $yo->view) { ?>
<form name="yokokuForm" id="yokokuForm" method="post" action="<?= $yo->self ?>">
<table>
<tr>
	<td>名前</td>
	<td><input id="inputName" type="text" name="name" maxlength="<?= $yo->nameLimit ?>" value="<?= htmlspecialchars($yo->c_name, ENT_QUOTES, 'UTF-8') ?>" /></td>
</tr>

<tr>
	<td>予告</td>
	<td><textarea id="inputMessage" name="message" rows="3" cols="40"></textarea><input type="hidden" name="m" value="add" /> <input type="submit" name="submit" value="投稿" /><br />(140文字くらい)</td>
</tr>
</table>

</form>
<? } ?>

<?= $yo->display() ?>


<div id="footer">
<a href="http://ss.hamachiya.com/yokoku.out/">予告.out</a> - <a href="http://d.hatena.ne.jp/Hamachiya2/20080613/yokoku">Hamachiya2</a><br />
(ソースコード置いとくので、適当に改造して遊んでね！ → <a href="http://ss.hamachiya.com/yokoku.out/yokoku.out.zip">yokoku.out.zip</a>)
</div>


</body>
</html>
